


#==========================================================================================
#========SigBee2B==========================================================================

doSigbees:
	make incidentSigbeePrep           # generate source wavlet, velocity etc.
	python pycode/pySWLmuF.py   # incident wfld multiple
	python pycode/pySWLmuH.py   # incident wfld primary
	python pycode/pyMWdnF.py    # model weighting file
	python pycode/pySDLmuF.py   # synthetic data for multiple
	python pycode/pySDLmuH.py   # synthetic data for primary
	make invSigbeePrep
	python pyinvSigbee/pysolverRegF.H   # inversion for multiple
	python pyinvSigbee/pysolverRegH.py  # inversion for primary

Data/velmodel.H: Input/zigsmt.H
	Rm Data/velmodel.H
	Math file1=Input/zigsmt.H exp='file1*0.001' | Window3d n1=280 f1=20 >  Data/velmodel.H

Data/reflbpzig.H: Input/reflziggy.H
	Rm Data/reflbpzig.H	
	< Input/reflziggy.H Bandpass flo=0.005 fhi=0.02 | Scale scale_to=1. | Interp d1out=5. > $@

Data/sdNoiH8.H:
	cp syndat/sdNoiH8.H Data/sdNoiH8.H

Data/sdLmuF8.H:
	cp syndat/sdLmuF8.H Data/sdLmuF8.H

Data/rtmPrimary.H:
	< LSM/H/m//mLmuHTotaliter2.H Bandpass flo=0.005 fhi=0.02 | Scale scale_to=1. | Interp d1out=5. > $@

Data/InvPrimary.H:
	< LSM/H/m//mLmuHTotaliter40.H Bandpass flo=0.005 fhi=0.02 | Scale scale_to=1. | Interp d1out=5. > $@

Data/rtmMultiple.H:
	< LSM/F/m//mLmuFTotaliter2.H Bandpass flo=0.005 fhi=0.02 | Scale scale_to=1. | Interp d1out=5. > $@

Data/InvMultiple.H:
	< LSM/F/m//mLmuFTotaliter2.H Bandpass flo=0.005 fhi=0.02 | Scale scale_to=1. | Interp d1out=5. > $@


#=============================================================================================
#========One Layer Model =====================================================================

doOnelayer:
	make onelayerPrep         # wavelets, velocity, reflectivity 
	python pycode/pySWLmuC.py   # Create incident wavefields
	python pycode/pySDLmuC.py   # Create synthetic data
	make oneinvPrep            # weighting files
	python pyinv/pysolverRegA.py  # run inversion

Data/refl3v2.H: Input/refl3v2.H
	cp Input/refl3v2.H $@
	
Data/sdLmuA1.H:
	cp syndat/A/sdLmuA1.H $@
	
Data/rtmOneA.H:
	< LSM/A/m//mLmuATotaliter2.H Bandpass flo=0.005 fhi=0.02 | Scale scale_to=1. | Interp d1out=5. > Data/rtmOneA.H
	
Data/InvOneA.H:
	< LSM/A/m//mLmuATotaliter20.H Bandpass flo=0.005 fhi=0.02 | Scale scale_to=1. | Interp d1out=5. > Data/InvOneA.H
	
