#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path
import fileinput


# Version two submit 4 jobs at a Lmue in the current nodes

# -----------------------------------------------------------
#-----Define shots parameters ----------- *** NEED CHANGING ***
# -----------------------------------------------------------


nnode = 3  # max number of jobs to run simultaneously
jmax  = 10 # max amount of 20 sec to wait before qutting
sbin = "./bin"
#-------------------------------------------------------------

def Ratio(maindir,projdir,plet,K,Rname,modax,datax,iter):

	dirdm = projdir+"/dm/dmLmu"+plet
	dirggm = projdir+'/ggm/ggmLmu'+plet	
	dirgg = projdir+'/gg/ggLmu'+plet	
	ggmdggm = 0.
	ggDdggD = 0.

        cmd1 = "%s/%s adj=0 naxis=%s eps=1.0 infile=%sTotaliter%s.H outfile=%sTemp.H >/dev/null"%(sbin,Rname, modax, dirdm,iter,dirggm)
	print cmd1
        os.system(cmd1)

	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%sTemp.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ggmdggm = ggmdggm + float(str1)
	os.system('Rm %sTemp.H'%(dirggm))

        # calculating residual in data space
	for i in K[:]:
		shot = i
		# calculating ggdgg 
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg,shot,iter,projdir)
		print cmd1
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		ggDdggD = ggDdggD + float(str1)

	# Calculate the ratio
	if (ggmdggm > 0.):
		ratio = (ggDdggD/ggmdggm)**(0.5)
	else:
		ratio = 1.

	print 'Ratio calculation for iter', iter
	print 'ggmDggm ggDdggD', ggmdggm, ggDdggD
	print 'ratio', ratio


	return ratio



#############################################################################

def Adjoint(maindir, projdir, velfile, parfile, plet, K, smooth, lpfil, VDer, gauss, DW, soufile, MWfile, DWfile, Rname, eps,ratio, modax, nhx, iter):

	progname="rtmOff"
	jobscpt = maindir + '/pyinv/pyAdjointOneDir.py'
	outdir = maindir + '/outdir'
        dirrrm = projdir + '/rrm/rrmLmu'+plet
        dmm    = projdir + '/dm/dmMLmu'+plet
	
	npone = len(K)/nnode+1
	nless = npone-1
	npart = nless*nnode
	nfull=len(K)-npart	


	# -----------------------------------------------------------
        #---- First calculate eps A' Rm  ----------------------------
        # -----------------------------------------------------------
        # Set ramping of the eps from zero to maxeps over 5 iterations
        ramp=[0.2,0.4,0.6,0.8]
        
        if iter <= len(ramp):
        	EPS = ramp[iter-1]*eps*ratio
        	print 'EPS, ramp[iter-1], eps, ratio', EPS, ramp[iter-1], eps, ratio
        else:
        	EPS = eps*ratio
        
        cmd1 = "%s/%s adj=1 naxis=%s eps=%s infile=%siter%s.H outfile=%siter%s.H >/dev/null "%(sbin,Rname, modax, EPS, dirrrm,iter,dmm,iter)
	print cmd1
        os.system(cmd1)

	# -----------------------------------------------------------
        #---- Define output files and output directories ------------
        # -----------------------------------------------------------
	outname = [0]

	for i in range(1,len(K)+1): 	
		stg1 = '%s/Adj%s%s.iter%s'%(outdir,plet,i,iter)   # *** NEED CHANGING ***
		outname.append(stg1)
		stg2 = '/bin/rm -rf %s'%(outname[i])
		os.system(stg2)
		i = i+1

	# -----------------------------------------------------------
        #---- Run the jobs  -----------------------------------------
        # -----------------------------------------------------------
        for i in range(1,len(K)+1):
        	shot = K[i-1]
		os.system("sleep 2")	
		submitted = 0
		while (submitted == 0):
			# flag = number of job running
			os.system("ps >&"+projdir+"/file.log")
			flag = os.system("grep -c "+progname+" "+projdir+"/file.log >&"+projdir+"/count.txt")
			f = open(projdir+'/count.txt')
			os.system("rm -f "+projdir+"/file.log "+projdir+"/count.txt")
			flag = int(f.readline())	
			print 'number of proc found', flag	
		
			if (flag < nnode):
				print 'Adjoint: submitting shot #', shot
				stg1 = '%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s &'%(jobscpt,shot,shot, iter, maindir,projdir,plet, velfile, parfile, smooth, lpfil, VDer, gauss, DW, nhx, soufile, MWfile, DWfile)
				print stg1
				os.system(stg1)
				submitted = 1
			else:
				# print 'Number of proc',flag,'wait 20'
				os.system("sleep 20")


	
#	for i in range(1,len(K)+1):
#		j=1
#		shot=K[i-1]
#		print 'searching for filename:', outname[i]
#		while(not os.path.isfile(outname[i])):
#			stg2 = 'Adjoint shot %s iter %s not done, waiting %s'%(shot,iter,j)   
#			print stg2
#			os.system('sleep 20')
#			j=j+1
#			if (j >= jmax):
#				break

	# Do a final check to see if there are remaining process, if so, wait it out
	flag=1
	while(flag >=1):
		os.system("ps >&"+projdir+"/file.log")
		flag = os.system("grep -c "+progname+" "+projdir+"/file.log >&"+projdir+"/count.txt")
		f = open(projdir+'/count.txt')
		os.system("rm -f "+projdir+"/file.log "+projdir+"/count.txt")
		flag = int(f.readline())	
		print 'Number of proc',flag,'wait 20'
		os.system('sleep 20')

		
	print 'Adjoint for iter # ',iter,' is finished'
	 			
	return


#############################################################################

def Forward(maindir, projdir, velfile, parfile, plet, K, smooth, lpfil, VDer, gauss, DW, soufile, MWfile, DWfile, Rname, eps,ratio, modax, nhx, iter):

	progname='ForOff'
	jobscpt = maindir + '/pyinv/pyForwardOneDir.py'
	outdir = maindir + '/outdir'
	dirdm = projdir+"/dm/dmLmu"+plet
	dirggm = projdir+'/ggm/ggmLmu'+plet	

	npone = len(K)/nnode+1
	nless = npone-1
	npart = nless*nnode
	nfull=len(K)-npart	


	# -----------------------------------------------------------
        #---- First, calculate ggm - eps A dm  ----------------------
        # -----------------------------------------------------------
        # Set ramping of the eps from zero to maxeps over 5 iterations
        ramp=[0.2,0.4,0.6,0.8,1.0]
        
        if iter <= len(ramp):
        	EPS = ramp[iter-1]*eps*ratio
        else:
        	EPS = eps*ratio
        
        
        
        os.system('rm -f '+projdir+'/Epsilon.txt')
        if iter == 2:
		file = open(projdir+"/ResidualData.txt","w")
		cmd1 = "Iter ramp eps ratio EPS \n"
		file.writelines(cmd1);
	else:
		file = open(projdir+"/ResidualData.txt","a")
		
	cmd2 = "%s %s %s %s %s \n"%(iter, ramp[min(iter-1,len(ramp)-1)],eps,ratio,EPS)
	file.writelines(cmd2);
	file.close()
        
        cmd1 = "%s/%s adj=0 naxis=%s eps=%s infile=%sTotaliter%s.H outfile=%siter%s.H >/dev/null"%(sbin,Rname, modax, EPS, dirdm,iter,dirggm,iter)
	print cmd1
        os.system(cmd1)

	# -----------------------------------------------------------
        #---- Define output files and output directories ------------
        # -----------------------------------------------------------
	outname = [0]

	for i in range(1,len(K)+1): 	
		stg1 = '%s/For%s%s.iter%s'%(outdir,plet,i,iter)   # *** NEED CHANGING ***
		outname.append(stg1)
		stg2 = '/bin/rm -rf %s'%(outname[i])
		os.system(stg2)
		i = i+1

	# -----------------------------------------------------------
        #---- Run the jobs  -----------------------------------------
        # -----------------------------------------------------------
	for i in range(1,len(K)+1):
		shot=K[i-1]
		os.system("sleep 2")		
		submitted = 0
		while (submitted == 0):
			# flag = number of job running
			os.system("ps >&"+projdir+"/file.log")
			flag = os.system("grep -c "+progname+" "+projdir+"/file.log >&"+projdir+"/count.txt")
			f = open(projdir+'/count.txt')
			os.system("rm -f "+projdir+"/file.log "+projdir+"/count.txt")
			flag = int(f.readline())	
			print 'number of proc found', flag	
		
			if (flag < nnode):
				print 'Forward: submitting shot #', shot
				stg1 = '%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s &'%(jobscpt,shot,shot, iter, maindir,projdir,plet, velfile, parfile, smooth, lpfil, VDer, gauss, DW, nhx, soufile, MWfile, DWfile)
				print stg1
				os.system(stg1)
				submitted = 1
			else:
				print 'Number of proc',flag,'wait 20'
				os.system("sleep 20")


	
#	for i in range(1,len(K)+1):
#		shot = K[i-1]
#		j=1
#		print 'searching for filename:', outname[i]
#		while(not os.path.isfile(outname[i])):
#			stg2 = 'Forward shot %s iter %s not done, waiting %s'%(shot,iter,j)   
#			print stg2
#			os.system('sleep 20')
#			j=j+1
#			if (j >= jmax):
#				break

	# Do a final check to see if there are remaining process, if so, wait it out
	flag=1
	while(flag >=1):
		os.system("ps >&"+projdir+"/file.log")
		flag = os.system("grep -c "+progname+" "+projdir+"/file.log >&"+projdir+"/count.txt")
		f = open(projdir+'/count.txt')
		os.system("rm -f "+projdir+"/file.log "+projdir+"/count.txt")
		flag = int(f.readline())
		print 'Number of proc',flag,'wait 20'	
		os.system('sleep 20')

	print 'Forward for iter # ',iter,' is finished'
	 			
	return

		
		
	


# ####################################


def Add(d1,  iter, naxis, K,dmm):
	# naxis: number of axes in files to be summed
        d1BK=d1+"BK"

        nblock = len(K)/10           # sum 10 shots at a time
        nLB = len(K) - nblock*10
        if (nLB == 0):        	
        	nLB = 10
        else:
        	nblock = len(K)/10+1
        		
        # Calculating the first nblock-1 blocks, 10 files per block
	for block in range(1,nblock):
     		print 'Block #', block 
        	i = (block-1)*10
    		print 'summing dm files for block ', block 
    		cmd1 = "%s/SUMMING.x nfile=10 naxis=%s outfile=%s%s.H "%(sbin,naxis,d1BK,block)
    		for i in range(1,10+1):
	    		cmd1 = cmd1+ "file%s=%s%siter%s.H "%(i, d1,K[i-1],iter)
    		cmd1 = cmd1+' >/dev/null'	
    		print cmd1
   		os.system(cmd1)

  	# Calculate the last block, contains nLB files
  	print 'Block #', nblock
  	block = nblock	
  	i = (block-1)*10+1
    	print 'summing dm files for block ', block 
    	cmd1 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%s%s.H "%(sbin,nLB,naxis,d1BK,block)
    	for i in range(1,nLB+1):
    		cmd1=cmd1+' file%s=%s%siter%s.H '%(i,d1,K[i-1+len(K)-nLB],iter)
    	
    	cmd1= cmd1+' >/dev/null'
    	print cmd1
    	os.system(cmd1)
    		
                 	  	  	  	
	# Sum all the block to form a big model, assume nblock <= 9 
	# Final dm = dmD + dmM 
	print 'summing All blocks for iter', iter
	if (nblock == 1):
		cmd1 = "Math file1=%s1.H file2=%siter%s.H exp='1.0*file1+file2' > %sTotaliter%s.H"%(d1BK, dmm, iter, d1,iter)
		cmd2 = "Rm %s1.H"%(d1BK)
		print cmd1
		print cmd2
		os.system(cmd1)
		os.system(cmd2)
	else: 
		cmd1 = "%s/SUMMING.x nfile=%s naxis=%s outfile=%sTotaliter%s.H file1=%siter%s.H "%(sbin,nblock+1, naxis, d1, iter, dmm, iter)
		cmd2 = "Rm "
		for i in range(1, nblock+1):
			cmd1 = cmd1 + ' file%s=%s%s.H'%(i+1,d1BK,i)
			cmd2 = cmd2 + ' %s%s.H'%(d1BK,i)
		cmd1 = cmd1 + ' >/dev/null' 
		print cmd1
		print cmd2
		os.system(cmd1)
		os.system(cmd2)
	
	return
           	  	  	  	
	

# ####################################	
# Calculate the alpha only using double precision

def DPcalCG(projdir, plet,K,iter,datax, modax, dirdm, dirggm, dirgg, dirrr, dirrrm):
	ggdgg = 0.
	ggdrr = 0.
	resid = 0.
	residD = 0.
        residm = 0.
        dmDdm = 0.
	ggmdggm = 0.
	ggDdggD = 0.
	ggmdrrm = 0.
	ggDdrrD = 0.	
        # Calculagte residual in model space
        # Calculate ddmDddm
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%sTotaliter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirdm,iter,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	dmDdm = dmDdm + float(str1)       
	# Calculate ggmdggm
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ggmdggm = ggmdggm + float(str1)
	# calculate ggmdrrm
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,dirrrm,iter,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ggmdrrm = ggmdrrm + float(str1)
	# calculate rrmdrrm
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirrrm,iter,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	residm = residm + float(str1)
        # calculating residual in data space
	for i in K[:]:
		shot = i
		# calculating ggdgg 
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg,shot,iter,projdir)
		print cmd1
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		ggDdggD = ggDdggD + float(str1)
		# Calculating ggdrr
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg,shot,iter,dirrr,shot,iter,projdir)
		print cmd1
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		ggDdrrD = ggDdrrD + float(str1)
		# calculating rrdrr
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirrr,shot,iter,projdir)
		print cmd1
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		residD = residD + float(str1)
	
	ggdgg = ggDdggD + ggmdggm
	ggdrr = ggDdrrD + ggmdrrm
	resid = residD  + residm


        # Perform cg step to get alpha
	os.system("rm -f "+projdir+"/alpha.txt")
	cmd1="%s/modcgstep.x Forget=1 ggdgg=%s ggdrr=%s outtag=%s/alpha.txt >/dev/null "%(sbin,ggdgg,ggdrr,projdir)
	print cmd1
	os.system(cmd1)
	f = open(projdir+"/alpha.txt")
	alpha = float(f.readline())	
	beta = 0.
	f.close()
	
	# Saves the residual in data space
	os.system('rm -f '+projdir+'/ResidualData.txt')
	file = open(projdir+"/ResidualData.txt","w")
	cmd1 = "Iter ggDdggD ggDdrrD ssDdssD ssDdrrD ssDdggD residD \n"
	file.writelines(cmd1);
	cmd1 = "1 %s %s 0. 0. 0. %s \n "%(ggDdggD, ggDdrrD,residD)
	file.writelines(cmd1);
	file.close()
        # Saves the residual in model space
	os.system('rm -f '+projdir+'/ResidualModel.txt')
	file = open(projdir+"/ResidualModel.txt","w")
	cmd1 = "Iter ggmdggm ggmdrrm ssmdssm ssmdrrm ssmdggm residm \n"
	file.writelines(cmd1);
	cmd1 = "1 %s %s 0. 0. 0. %s \n "%(ggmdggm, ggmdrrm,residm)
	file.writelines(cmd1);
	file.close()
	# Saves the total residual 
	os.system('rm -f '+projdir+'/ResidualTotal.txt')
	file = open(projdir+"/ResidualTotal.txt","w")
	cmd1 = "Iter ggdgg ggdrr ssdss ssdrr ssdgg resid \n"
	file.writelines(cmd1);
	cmd1 = "1 %s %s 0. 0. 0. %s \n "%(ggdgg, ggdrr,resid)
	file.writelines(cmd1);
	file.close()
	# Saves the percent residual
	file = open(projdir+"/ResidualPercent.txt","w")
	cmd1 = "Iter ggdgg ggdrr ssdss ssdrr ssdgg resid \n"
	file.writelines(cmd1);
	cmd1 = "1 %s %s 0.00 0.00 0.00 %s \n "%(str(round(ggmdggm/ggdgg*100,2)), str(round(ggmdrrm/ggdrr*100,2)), str(round(residm/resid*100,2)))
	file.writelines(cmd1);
	file.close()


        # Save the step size
        file = open(projdir+'/Reportsave.txt',"w")
	file.writelines("iter alpha beta dmDdm Data_resid Model_resid Objective \n")
	cmd1 = " 1 %s 0. %s %s %s %s \n "%(alpha, dmDdm, residD, residm, resid)
	file.writelines(cmd1);
	file.close()



	return alpha, beta

# ####################################	
# Calculate the alpha and beta using double precision

def DPcalCD(projdir, plet, K,iter,datax,modax, dirdm, dirggm, dirgg, dirrr, dirrrm, dirss, dirssm):
	print 'calculating Dot Product for iter ', iter
	ggdrr = 0.
	ggdgg = 0.
	ssdss = 0.
	ssdrr = 0.
	ssdgg = 0.
	resid = 0.
	dmDdm = 0.
	ggmdrrm = 0.
	ggmdggm = 0.
	ssmdssm = 0.
	ssmdrrm = 0.
	ssmdggm = 0.
	residm = 0.
	ggDdrrD = 0.
	ggDdggD = 0.
	ssDdssD = 0.
	ssDdrrD = 0.
	ssDdggD = 0.
	residD = 0.
        # Calculagte residual in model space
        # Calculate ddmDddm
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%sTotaliter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirdm,iter,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	dmDdm = dmDdm + float(str1) 
	# Calculate ggmdggm
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ggmdggm = ggmdggm + float(str1)
	# calculate ggmdrrm
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,dirrrm,iter,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ggmdrrm = ggmdrrm + float(str1)
	# calculate ggmdssm
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,dirssm,iter,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ssmdggm = ssmdggm + float(str1)
	# Calculate ssmdssm
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirssm,iter,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ssmdssm = ssmdssm + float(str1)
	# calculate ssmdrrm
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirssm,iter,dirrrm,iter,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ssmdrrm = ssmdrrm + float(str1)
        # Calculate rrmdrrm
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirrrm,iter,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	residm = residm + float(str1)

        # Dot products of data space Residual
	for i in K[:]:
		shot=i
		
		# calculating ggdgg 
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg,shot,iter,projdir)
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		print 'ggdgg, node', str1, i
		ggDdggD = ggDdggD + float(str1)
		# Calculating ggdrr
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg,shot,iter,dirrr,shot,iter,projdir)
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		ggDdrrD = ggDdrrD + float(str1)
		# calculating ssdss
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirss,shot,iter,projdir)
#		print cmd1
		os.system(cmd1)
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		ssDdssD = ssDdssD + float(str1)	
		# calculating rrdrr
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirrr,shot,iter,projdir)
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		residD = residD + float(str1)
		# Calculating ssdrr
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin, datax,dirss,shot,iter,dirrr,shot,iter,projdir)
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		ssDdrrD = ssDdrrD + float(str1)
		# Calculating ssdgg
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin, datax,dirss,shot,iter,dirgg,shot,iter,projdir)
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		ssDdggD = ssDdggD + float(str1)
	

	ggdgg = ggDdggD + ggmdggm
	ggdrr = ggDdrrD + ggmdrrm
	ssdss = ssDdssD + ssmdssm
	ssdrr = ssDdrrD + ssmdrrm
	ssdgg = ssDdggD + ssmdggm
	resid = residD  + residm


        # CG step to calculate alpha and beta
	os.system("rm -f "+projdir+"/alpha.txt")
	cmd1 = "%s/modcgstep.x Forget=0 ggdgg=%s ggdrr=%s ssdss=%s ssdrr=%s ssdgg=%s outtag='%s/alpha.txt' >/dev/null "%(sbin,ggdgg,ggdrr,ssdss,ssdrr,ssdgg,projdir)
	os.system(cmd1)
	f = open(projdir+"/alpha.txt")
	alpha = float(f.readline())
	beta  = float(f.readline())
	f.close()	


	# Saves the residual in data space
	file = open(projdir+"/ResidualData.txt","a")
	cmd1 = "%s %s %s %s %s %s %s \n "%(iter, ggDdggD, ggDdrrD,ssDdssD,ssDdrrD,ssDdggD,residD)
	file.writelines(cmd1);
	file.close()
        # Saves the residual in model space
	file = open(projdir+"/ResidualModel.txt","a")
	cmd1 = "%s %s %s %s %s %s %s \n "%(iter, ggmdggm, ggmdrrm,ssmdssm, ssmdrrm, ssmdggm, residm)
	file.writelines(cmd1);
	file.close()
	# Saves the total residual 
	file = open(projdir+"/ResidualTotal.txt","a")
	cmd1 = "%s %s %s %s %s %s %s \n "%(iter, ggdgg, ggdrr, ssdss, ssdrr, ssdgg, resid)
	file.writelines(cmd1);
	file.close()

	# Saves the percent residual
	file = open(projdir+"/ResidualPercent.txt","a")
	cmd1 = "%s %s %s %s %s %s %s \n "%(iter, str(round(ggmdggm/ggdgg*100,2)), str(round(ggmdrrm/ggdrr*100,2)), str(round(ssmdssm/ssdss*100,2)), str(round(ssmdrrm/ssdrr*100,2)), str(round(ssmdggm/ssdgg*100,2)), str(round(residm/resid*100,2)))
	file.writelines(cmd1);
	file.close()

        # Save the alpha, beta, and residual
	file = open(projdir+'/Reportsave.txt', 'a')            
	cmd1 = " %s %s %s %s %s %s %s \n"%(iter,alpha,beta, dmDdm, residD, residm, resid)
	file.writelines(cmd1);
	file.close()

	return alpha, beta, resid


# ####################################
def ResidCal(projdir, plet, K,iter,datax, dirrr):
	resid = 0.
	for i in K[:]:
		shot = i
		# calculating rrdrr
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirrr,shot,iter,projdir)
		print cmd1
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		resid = resid + float(str1)
		
	return resid
# ###################################

def removefiles(maindir,nblock,dboc,iter,nitersave,saveshot,plet):
	d1BK = maindir +"/dm/dmKBB"
	dirgg = maindir + "/gg/ggLmu%s"%(plet)
	dirss = maindir + "/ss/ssLmu%s"%(plet)
	dirrr = maindir + "/rr/rrLmu%s"%(plet)
	dirs  = maindir + "/s/sLmu%s"%(plet)
	dirm  = maindir + "/m/mLmu%s"%(plet)
	dirdm = maindir + "/dm/dmLmu%s"%(plet)
	os.system("rm -f "+maindir+"/alpha.txt")
	
	for i in K[:]:
		shot = i
		# Erase all the dmD%.H file after each BK is calculated
  		os.system("Rm -f "+dirdm+`shot`+"iter"+`iter`+".H ") 

  	# Erase all the dmDBK%.H file after Total is calculated
		os.system("Rm -f "+d1BK+"*.H")

	
	# Erase old rr, gg, and ss, unless request to be saved    
#	for i in range(1,(nblock-1)*dboc+1):
#		shot = 
#		os.system("Rm -f "+dirgg+`shot`+"iter"+`iter`+".H ")
#		os.system("Rm -f "+dirss+`shot`+"iter"+`iter`+".H ")
#		if ((iter%nitersave == 0) & (shot != saveshot)):
#			os.system("Rm -f "+dirrr+`shot`+"iter"+`iter`+".H ")
	
	# Erase old m, dm, and s
#	os.system("Rm -f "+dirs+"Total"+"iter"+`iter`+".H ")
#	if (iter%nitersave == 0):
#		os.system("Rm -f "+dirm+"Total"+"iter"+`iter`+".H "+dirdm+"Total"+"iter"+`iter`+".H ")
			
	return		
