program VelSmooth
! Read in a velocity model, smooth the slowness with specified width
! Output the smoothed velocity model.
! width  : smoothing width


  use sep
  use smooth_mod
  use type_mod

implicit none


 type(velo) :: vel


 integer    :: ix, iz,  nx, nz, width, idevi, imid
 real       :: zw, wvel
 real, dimension(:,:), allocatable :: vvel, slow

 call sep_init()


  ! Read original velocity model param
   call from_history("n1", vel%z%n);  call from_history("d1", vel%z%d);  call from_history("o1",vel%z%o);
   call from_history("n2", vel%x%n);  call from_history("d2", vel%x%d);  call from_history("o2",vel%x%o);

   call from_param('zw',zw,175.)
   call from_param("wvel",wvel,1500.)

   nz = vel%z%n;
   nx = vel%x%n;
   imid = zw/vel%z%d+1.5

   write(0,*) 'zw, wvel, imid', zw, wvel, imid

   allocate(vvel(nz,nx), slow(nz,nx))


   ! Read in the background velocity
    call sep_read( vvel(1:nz,1:nx))

    do ix=1,nx
       do iz=53,1,-1
          if (ix .gt. 255) write(0,*) vvel(iz,ix)
         if (vvel(iz,ix) .gt. 2000) then
             idevi = int((iz-50)/3.)
             write(0,*) 'ix,iz', ix, iz, idevi, imid
             slow(1:imid+idevi,ix) = wvel;
             slow(imid+idevi:nz,ix) = vvel(imid+idevi:nz,ix)
             exit
         end if 
       end do
    end do

   do ix=400,434
      do iz=50,1,-1
      if (vvel(iz,ix) .gt. 2000) then
             idevi = int((iz-50)/2.)
             write(0,*) 'ix,iz', ix, iz, idevi, imid
             slow(1:imid+idevi,ix) = wvel;
             slow(imid+idevi:nz,ix) = vvel(imid+idevi:nz,ix)
             exit
         end if 
      end do
   end do
   
   do ix=413,420
      slow(12:nz,ix) = vvel(12:nz,ix)
   end do
   
   do ix=395,400
      slow(6:nz,ix) = vvel(6:nz,ix)
   end do
   
!----------------------------------------------
! Output

  call sep_write(slow,dim1=nz, dim2=nx, esize=4)
  write(0,*) "vel%z%n", vel%z%n
  call to_history("n1",vel%z%n); call to_history("d1",vel%z%d);  call to_history("o1",vel%z%o);
  call to_history("n2",vel%x%n); call to_history("d2",vel%x%d);  call to_history("o2",vel%x%o);
  


end program
