program ApplyWgt
! Output the data space weighting file
! Dimension: n1 = nrx
!            n2 = nt
!            n3 = UD


  use sep
  
  implicit none
  
  integer                   :: nrx,nt,n3
  integer                   :: irx,it,i3
  real                      :: orx, ot, o3
  real                      :: drx, dt, d3
  character(len=128)        :: outfile_, Wgtfile_
  real, dimension(:,:,:), allocatable   ::  inArray, outArray, WgtArray

  call sep_init()

  call from_param("outfile", outfile_);
  call from_param("Wgtfile", Wgtfile_);


  call from_history("n1",nrx);     call from_history("d1",drx);    call from_history("o1",orx);
  call from_history("n2", nt);     call from_history("d2",dt);    call from_history("o2",ot);
  call from_history("n3", n3,1);     call from_history("d3",d3,1.);    call from_history("o3",o3,0.);

  allocate(inArray(nrx,nt,n3), outArray(nrx,nt,n3), WgtArray(nrx,nt,n3))



  write(0,*) 'nrx, drx, orx', nrx, drx, orx
  write(0,*) 'nt, dt, ot', nt, dt ,ot
  write(0,*) 'n3' , n3


  call sep_read(inArray);

  call sep_read(WgtArray, Wgtfile_);

  do i3=1,n3
  do irx=1,nrx
    do it=1,nt
        outArray(irx,it,i3) = inArray(irx,it,i3)*WgtArray(irx,it,i3)
    end do
  end do
  end do

  call sep_write(outArray,outfile_,dim1=nrx, dim2=nt, dim3=n3, esize=4)

         call auxputch("n1",'i',nrx, trim(outfile_));     
         call auxputch("d1",'f',drx, trim(outfile_));   
         call auxputch("o1",'f',orx,trim(outfile_));
         call auxputch("label1",'s','Rx',trim(outfile_));

	  call auxputch("n2",'i',nt, trim(outfile_));     
	  call auxputch("d2",'f',dt, trim(outfile_));   
	  call auxputch("o2",'f',ot,trim(outfile_));
          call auxputch("label2",'s','time',trim(outfile_));

	  call auxputch("n3",'i',n3, trim(outfile_));     
	  call auxputch("d3",'f',d3, trim(outfile_));   
	  call auxputch("o3",'f',o3,trim(outfile_));
          call auxputch("label3",'s','UD',trim(outfile_));



end program
