program Applyfilter


! Estimate filter a onto b 
!      a*b = c
! convolution expressed in matrix multiplication
!      aB=c
! input:
!     op = 1 (a convolve with b);  [2] A is a matrix
!     in = filename for a series
!     bfile = filename for b series
! Output:
!     out = filename for output series


  use sep
  use EstFil_mod
  
  
  implicit none
  

  character(len=128)    :: bfile_
  
  logical              :: dott
  integer              :: op, na, nb, stat
  integer              :: n1a, n2a, ia, ib, ic
  
  real                 :: db, ob
  real, pointer :: a(:), b(:), c(:)
 
  call sep_init()
  
  call from_param("bfile",bfile_); 
  call from_param("op",op,1)
  
    if (op .eq. 1) then    
    call from_history("n1",na); 
  else
      call from_history("n1",n1a); 
    call from_history("n2",n2a); 
  end if 
  
  call from_aux(bfile_,"n1",nb); call from_aux(bfile_,"d1",db); call from_aux(bfile_,"o1",ob);
  
 
  if (op .eq. 2) then
     na = nb*nb
    if ((n1a .ne. nb) .and. (n2a .ne. nb))  call erexit('n1a*n2a .ne. nb')
  end if 
    
  write(0,*) 'write to history here'  
  call to_history("n1",nb); call to_history("d1",db); call to_history("o1",ob)
 call to_history("n2",1); call to_history("d2",db); call to_history("o2",ob)
  
  call sep_close()  
  
  write(0,*) '**************************'
  write(0,*) 'op',op
  write(0,*) 'na, nb', na, nb
  write(0,*) 'bfile', bfile_
  write(0,*) '**************************'
  
  
  if (nb .gt. 1000000) call erexit('nb > 1e6')
  if (na .gt. 10000000) call erexit('na > 1e6')
  
  allocate(a(na),b(nb),c(nb))
  
  do ia=1,na
     a(ia) = 0.
  end do
  do ib=1,nb
     b(ib) = 0.
  end do
  do ic=1,nb
     c(ic) = 0.
  end do
    
  call sep_read(b,bfile_)
  call sep_read(a)
  write(0,*) 'sum b a', sum(b), sum(a)
  
  call estfil_init(na, nb, nb, b);
  
          
  ! Now apply filter to b to get cout
  if (op .eq. 1) then
    stat = estfil_lop(.false.,.false.,a,c)
  else  
    stat = estfil2_lop(.false.,.false.,a,c)
  end if
  
  call sep_write(c);      
  call estfil_close()
  
  write(0,*) 'deallocate'
!  deallocate(a)
!  deallocate(a, stat=stat)
!  if(stat /=0) call erexit("cant deallocate a")
 ! deallocate(b, stat=stat)
!  if(stat /=0) call erexit("cant deallocate b")
!  deallocate(c, stat=stat)
!  if(stat /=0) call erexit("cant deallocate c")  






end program
