program DataTaper
! Taper the input data in all 3 edges
! Input bndt, bndx
! Input cosine 

  use sep
  use waveprop_mod
  
  implicit none
  
  integer                   :: nx,nt,n3
  integer                   :: ix,it,i3
  integer                   :: bndx, bndt
  real                      :: ox, ot, o3
  real                      :: dx, dt, d3, t
  real, dimension(:), allocatable      :: xtaper, ttaper
  real, dimension(:,:), allocatable      :: ctaper  
  character(len=128)        :: outfile_
  real, dimension(:,:,:), allocatable   ::  inArray, outArray

  call sep_init()

  call from_param("outfile", outfile_);

  call from_param("bndx",bndx,100)
  call from_param("bndt",bndt,100)


  call from_history("n1",nx);     call from_history("d1",dx);    call from_history("o1",ox);
  call from_history("n2", nt);     call from_history("d2",dt);    call from_history("o2",ot);
  call from_history("n3", n3);     call from_history("d3",d3);    call from_history("o3",o3);
  
  allocate(inArray(nx,nt,n3),outArray(nx,nt,n3))
  allocate(xtaper(bndx), ttaper(bndt))
  allocate(ctaper(bndx,bndt))

  call sep_read(inArray);

  outArray = inArray

  call  tapersetupCos(bndt,bndx,ttaper,xtaper,ctaper,0.5,0.5)
  write(0,*) 'sum xtaper, ttaper, ctaper', sum(xtaper), sum(ttaper), sum(ctaper)
  
       ! Corner
       do i3=1,n3
         do it=1,bndt
           do ix=1,bndx

              outArray(ix,it,i3) = inArray(ix,it,i3)*ctaper(ix,it);         ! top left
              outArray(ix,nt-it+1,i3) = inArray(ix,nt-it+1,i3)*ctaper(ix,it)          ! top right
              outArray(nx-ix+1,nt-it+1,i3) = inArray(nx-ix+1,nt-it+1,i3)*ctaper(ix,it)   ! bottom right
              outArray(nx-ix+1,it,i3) = inArray(nx-ix+1,it,i3)*ctaper(ix,it)          ! bottom left
          end do
         end do
       end do

       do i3=1,n3
         do ix=bndx+1,nx-bndx

          outArray(ix, 1:bndt,i3) = inArray(ix, 1:bndt,i3) * xtaper(1:bndt:+1);           !left
	  outArray(ix,nt-bndt+1:nt,i3) = inArray(ix,nt-bndt+1:nt,i3) * xtaper(bndt:1:-1)  !right
         end do
       end do

       do i3=1,n3
         do it=bndt+1,nt-bndt

          outArray(1:bndx,it,i3) = inArray(1:bndx,it,i3) * ttaper(1:bndx:+1);             ! top
          outArray(nx-bndx+1:nx,it,i3) = inArray(nx-bndx+1:nx,it,i3) * ttaper(bndx:1:-1)  ! bottom
         end do
       end do   
    
  call sep_write(outArray,outfile_,dim1=nx, dim2=nt, dim3=n3, esize=4)


         call auxputch("n1",'i',nx, trim(outfile_));     
         call auxputch("d1",'f',dx, trim(outfile_));   
         call auxputch("o1",'f',ox,trim(outfile_));
         call auxputch("label1",'s','x',trim(outfile_));

	  call auxputch("n2",'i',nt, trim(outfile_));     
	  call auxputch("d2",'f',dt, trim(outfile_));   
	  call auxputch("o2",'f',ot,trim(outfile_));
          call auxputch("label2",'s','time',trim(outfile_));

	  call auxputch("n3",'i',n3, trim(outfile_));     
	  call auxputch("d3",'f',d3, trim(outfile_));   
	  call auxputch("o3",'f',o3,trim(outfile_));
          call auxputch("label3",'s','UD',trim(outfile_));


end program
