program DataTaperHor
! Taper the input data in all 3 edges
! Input bnd2, bnd1
! Input cosine 

  use sep
  use waveprop_mod
  
  implicit none
  
  integer                   :: n1,n2,n3
  integer                   :: i1,i2,i3
  integer                   :: bnd2
  real                      :: o1, o2, o3
  real                      :: d1, d2, d3
    real                        :: pi=3.14159265359  
  real, dimension(:), allocatable      :: taper2

  character(len=128)        :: outfile_
  real, dimension(:,:,:), allocatable   ::  inArray, outArray

  call sep_init()

  call from_param("outfile", outfile_);

  call from_param("bnd2",bnd2,100)

       
       

  call from_history("n1",n1);     call from_history("d1",d1);    call from_history("o1",o1);
  call from_history("n2", n2);     call from_history("d2",d2);    call from_history("o2",o2);
  call from_history("n3", n3);     call from_history("d3",d3);    call from_history("o3",o3);
  
  allocate(inArray(n1,n2,n3),outArray(n1,n2,n3))
  allocate(taper2(bnd2))
  
  
       ! Left and right edge
       do i2=1,bnd2
          taper2(i2) = 0.5 + 0.5*cos(pi*(bnd2-i2)/bnd2)
       end do
  
  call sep_read(inArray);

  outArray = inArray

      

       do i3=1,n3
         do i1=1,n1
          outArray(i1, 1:bnd2,i3) = inArray(i1, 1:bnd2,i3) * taper2(1:bnd2:+1);           !left
	  outArray(i1,n2-bnd2+1:n2,i3) = inArray(i1,n2-bnd2+1:n2,i3) * taper2(bnd2:1:-1)  !right
         end do
       end do
 
    
  call sep_write(outArray,outfile_,dim1=n1, dim2=n2, dim3=n3, esize=4)


         call auxputch("n1",'i',n1, trim(outfile_));     
         call auxputch("d1",'f',d1, trim(outfile_));   
         call auxputch("o1",'f',o1,trim(outfile_));
         call auxputch("label1",'s','x',trim(outfile_));

	  call auxputch("n2",'i',n2, trim(outfile_));     
	  call auxputch("d2",'f',d2, trim(outfile_));   
	  call auxputch("o2",'f',o2,trim(outfile_));
          call auxputch("label2",'s','time',trim(outfile_));

	  call auxputch("n3",'i',n3, trim(outfile_));     
	  call auxputch("d3",'f',d3, trim(outfile_));   
	  call auxputch("o3",'f',o3,trim(outfile_));
          call auxputch("label3",'s','UD',trim(outfile_));


end program
