module EstFil_mod


  implicit none
  
  integer                          :: nna, nnb, nnc
  real, dimension(:), allocatable  :: bArr
  
  
contains




  subroutine estfil_init(nna_in,nnb_in,nnc_in,b_in)
  
  integer, intent(in)  :: nna_in, nnb_in, nnc_in
  integer              :: ib
  real, dimension(:)   :: b_in
  
  
  nna = nna_in;  nnb=nnb_in;  nnc=nnc_in;
  
  allocate(bArr(nnb))
  
  do ib=1,nnb
     bArr(ib) = b_in(ib)
  end do
  
  
  end subroutine estfil_init
!---------------------------------------------------------------------------  
  
  integer function  estfil_lop(adj,add,mod,dat)  result(stat)
  
    logical, intent(in)     :: adj, add
    integer     :: i, ia, ic
    real,  intent(inout)    :: mod(:), dat(:)
    
    stat=1
    
    if (.not. add) then
       if (adj) then
          do i=1,nna
             mod(i) = 0.
          end do
       else
          do i=1,nnc
            dat(i) = 0.
          end do
       end if
    end if
    
    if (adj) then   
      do ic=1,nnc
        do ia=1,min(ic,nna)   
           mod(ia) = mod(ia) + dat(ic)*bArr(ic-ia+1)
        end do
      end do
    else ! forward
      do ic=1,nnc
        do ia=1,min(ic,nna)   
           dat(ic) = dat(ic) + bArr(ic-ia+1)*mod(ia)
        end do
      end do
    
    end if
  
    stat=0
  
  end function estfil_lop
  
!---------------------------------------------------------------------------
  integer function  estfil2_lop(adj,add,mod,dat)  result(stat)
  
    logical, intent(in)     :: adj, add
    integer     :: i, ia, ia1, ia2, ic
    real,  intent(inout)    :: mod(:), dat(:)
    
    stat=1
    
    if (.not. add) then
       if (adj) then
          do i=1,nna
             mod(i) = 0.
          end do
       else
          do i=1,nnc
            dat(i) = 0.
          end do
       end if
    end if
    
    if (adj) then   
      do ic=1,nnc
         ia1 = ic
         do ia2=1,nnc
           ia = ia1+(ia2-1)*nnc
           mod(ia) = mod(ia) + dat(ic)*bArr(ia2)
        end do
      end do
    else ! forward
      do ic=1,nnc
         ia1 = ic
        do ia2=1,nnc            
           ia = ia1+(ia2-1)*nnc   
           dat(ic) = dat(ic) + bArr(ia2)*mod(ia)
        end do
      end do
    
    end if
  
    stat=0
  
  end function 
  
!---------------------------------------------------------------------------  
  subroutine estfil_close()  
    deallocate(bArr)
  end subroutine estfil_close
  
end module
  
  
  
