program SecondDer

! Take Second derivative of input file
! Only along the first axis

  use sep
  use waveprop_mod
  use smooth_mod
  use type3d_mod

implicit none


 type(velo) :: mm

 logical    :: adj
 integer    :: ix, iz, i3, nx, nz, n3
 real       :: nr
 real, dimension(:), allocatable  ::  temp
 real, dimension(:,:,:), allocatable :: model

 call sep_init()


   write(0,*) ' This is SecondDer program'


  ! Read back ground mmocity param
   call from_history("n1", mm%z%n);  call from_history("d1", mm%z%d);  call from_history("o1",mm%z%o);
   call from_history("n2", mm%x%n);  call from_history("d2", mm%x%d);  call from_history("o2",mm%x%o);
   call from_history("n3", n3,1);
  
   call from_param("adj",adj,.true.);

   nz = mm%z%n;
   nx = mm%x%n;

   write(0,*) 'nz,dz,oz', mm%z%n, mm%z%d, mm%z%o
   write(0,*) 'nx,dx,ox', mm%x%n, mm%x%d, mm%x%o
   write(0,*) 'adj', adj


   allocate( model(nz,nx,n3), temp(nz))


write(0,*) 'pass 1'

   ! Read in the background mmocity
    call sep_read( model(1:nz,1:nx,1:n3))


if (1 == 1) then

   ! take 2nd derivative of receiver wavefield
   do i3=1,n3     
     write(0,*) 'VDer filtering i3=', i3, 'out of', n3
     do ix=1,nx
      temp(:) = model(:,ix,i3)
      model(:,ix,i3) = 0.
        do iz=2,nz-1
          if (adj) then
              model(iz,ix,i3) = model(iz,ix,i3) + (2.*temp(iz) + -1.*temp(iz+1) + -1.*temp(iz-1))
          else
            model(iz,ix,i3) = model(iz,ix,i3) + 2*temp(iz)
            model(iz,ix,i3) = model(iz,ix,i3) + -1.*temp(iz+1)
            model(iz,ix,i3) = model(iz,ix,i3) + -1.*temp(iz-1)
          end if
        end do
     end do
   end do
  

   ! take 2nd derivative of receiver wavefield
!   do i3=1,n3     
!     do ix=1,nx
!      temp(:) = model(:,ix,i3)
!      call SecDer(temp, temp, nz, mm%z%d)
!      model(:,ix,i3) = temp(:)
!     end do
!   end do
 

end if

write(0,*) 'pass 3'
   
!----------------------------------------------
! Output

  call sep_write(model,dim1=nz, dim2=nx, dim3=n3, esize=4)

write(0,*) 'pass 4'
  
  call to_history("n1",mm%z%n); call to_history("d1",mm%z%d);  call to_history("o1",mm%z%o);
  call to_history("n2",mm%x%n); call to_history("d2",mm%x%d);  call to_history("o2",mm%x%o);
  call to_history("n3",n3)
  
  write(0,*) 'pass 5'

end program
