program Solver_ops
! Perform dot products using double precision
! cg  = 1: dot with itself
! print the dot result to stdout

  use sep
  
  implicit none
  
  integer                   :: cg
  integer                   :: naxis, nvolume
  integer                   :: n1,n2,n3,n4,n5
  integer                   :: i
  real                      :: o1, o2, o3, o4, o5
  real                      :: d1, d2, d3, d4, d5
  real*8                    :: DP, real1, real2
  character(len=128)        :: label1, label2, label3, label4, label5
  character(len=128)        :: getfile_
  character(len=128)        :: file1_, file2_, outfile_
  real, dimension(:), allocatable   ::  Array, Array2

  call sep_init()

  call from_param("cg", cg,0);
  call from_param("naxis",naxis);

  
  if ((naxis .gt. 5) .or. (naxis .lt. 1) ) call erexit('naxis must be between 1 to 5')
  
 
  if (cg .eq. 0) call from_param("file2", file2_); 
    
  call from_param("file1", file1_);
  call from_param("outfile", outfile_);

  getfile_ = file1_
  
  n1=1.; n2=1.; n3=1.;  n4=1.; n5=1.;

  if(naxis .ge. 1) then
     call from_aux(getfile_, "n1", n1);    call from_aux(getfile_,"d1",d1);     call from_aux(getfile_, "o1",o1);
     call from_aux(getfile_, "label1",label1);
  end if
  
  if (naxis .ge. 2) then
     call from_aux(getfile_, "n2", n2);    call from_aux(getfile_,"d2",d2);     call from_aux(getfile_, "o2",o2);
     call from_aux(getfile_, "label2",label2);
  end if
  
  if(naxis .ge. 3) then
     call from_aux(getfile_, "n3", n3);    call from_aux(getfile_,"d3",d3,1.);     call from_aux(getfile_, "o3",o3,0.);
     call from_aux(getfile_, "label3",label3);
  end if
  
  if (naxis .ge. 4) then
     call from_aux(getfile_, "n4", n4);    call from_aux(getfile_,"d4",d4);     call from_aux(getfile_, "o4",o4);
     call from_aux(getfile_, "label4",label4);
  end if
  
  if (naxis .ge. 5) then
     call from_aux(getfile_, "n5", n5);    call from_aux(getfile_,"d5",d5);     call from_aux(getfile_, "o5",o5);
     call from_aux(getfile_, "label5",label5);
  end if
  
  nvolume=n1*n2*n3*n4*n5
  allocate( Array(nvolume), Array2(nvolume))
  Array = 0.;
  Array2 = 0.;

  call sep_read(Array, file1_);



  if (cg .eq. 0) then
  	call sep_read(Array2, file2_ );
  end if
   
  write(0,*) 'n1, n2, n3, n4, n5', n1, n2, n3, n4, n5
  write(0,*) 'nvolume', nvolume

  ! Begin Dot product
  if (.not. cg) then
     do i=1,nvolume        
         real1 = Array(i);
         real2 = Array2(i);      
         DP = DP + real1*real2;
     end do
  else
     do i=1,nvolume        
         real1 = Array(i);     
         DP = DP + real1*real1;
     end do 
  end if

  open(unit=77,file=trim(outfile_))
  write(77,*) DP
  close(77)   

end program
