program TracemuteWgt
! Create a dataweighting file of 1's and 0's base on which trace is muted

  use sep
 
  implicit none
  
  integer                   :: nx,nt,n3
  integer                   :: ix,it,i3, i, nrow
  real                      :: ox, ot, o3
  real                      :: dx, dt, d3, t, d
  character(len=128)        :: outfile_, tracefile_
  real, dimension(:,:), allocatable     :: WgtArray
  real, dimension(:,:,:), allocatable   ::  inArray

  call sep_init()

  call from_param("outfile", outfile_);
  call from_param("tracefile",tracefile_);


  call from_history("n1",nx);     call from_history("d1",dx);    call from_history("o1",ox);
  call from_history("n2", nt);     call from_history("d2",dt);    call from_history("o2",ot);
  call from_history("n3", n3);     call from_history("d3",d3);    call from_history("o3",o3);
  
  allocate(inArray(nt,nx,n3), WgtArray(nt,nx))

  WgtArray =1. 


  !! Open the file 
  OPEN(2,FILE=tracefile_)

  read(2,*) d
  nrow = int(d)-1
  
  write(0,*) '********************'
  write(0,*) 'nx, nt, n3', nx, nt, n3
  write(0,*) 'nrow', nrow
  write(0,*) 'outfile_', outfile_
  write(0,*) 'tracefile_' , tracefile_
  write(0,*) '********************'
  
  do i=1,nrow
  
     read(2,*) d
     
     ix = int(d)
     write(0,*) 'muting ix= ', ix
     
     WgtArray(:,ix) = 0.
  
  
  end do

  CLOSE(2);
    
    
  call sep_write(WgtArray,outfile_,dim1=nt, dim2=nx,  esize=4)
  call sep_write(WgtArray,outfile_,dim1=nt, dim2=nx,  esize=4)


         call auxputch("n1",'i',nt, trim(outfile_));     
         call auxputch("d1",'f',dt, trim(outfile_));   
         call auxputch("o1",'f',ot,trim(outfile_));
         call auxputch("label1",'s','time',trim(outfile_));

	  call auxputch("n2",'i',nx, trim(outfile_));     
	  call auxputch("d2",'f',dx, trim(outfile_));   
	  call auxputch("o2",'f',ox,trim(outfile_));
          call auxputch("label2",'s','x',trim(outfile_));

	  call auxputch("n3",'i',n3, trim(outfile_));     
	  call auxputch("d3",'f',d3, trim(outfile_));   
	  call auxputch("o3",'f',o3,trim(outfile_));
          call auxputch("label3",'s','UD',trim(outfile_));


end program
