module type3d_mod

public                      :: blcIndex
public                      :: axis, velo, sou_grid, abc_values

!----------------------------------------------------

  ! Indexes for block
  type blcIndex
    integer        :: nblocks, grid_size, block_size
    integer        :: iib, padb, pade, ib, ie, dbloc 

    integer        :: bsz, n
    integer        :: effbsz, effbszlast, effn, bszlast
 
  end type

!--------------------------------------------------
  !!.. define type for axes
  type axis 
    integer 					:: n		! total number
    real    					:: d		! spacing
    real    					:: o		! origin
!!    real, allocatable				:: all(:)  	! values
  end type


!----------------------------------------------------

  ! define vel
  type velo
    type(axis) :: z, x, y, h
    real       :: zw, zsb
    logical     :: smooth    
  end type

!----------------------------------------------------

  ! define sou grid
  type sou_grid
     type(axis) :: z, x, y, t
     real       :: otsav, dtsav, zs
     real       :: dtup, dtdn, otup, otdn
     integer    :: ntsav, bfile, efile
     integer    :: ntup, ntdn

  end type 
!---------------------------------------------------

  ! define sou grid
  type rec_grid
     type(axis) :: z, x, y, t
     integer    :: nt         ! modeling grid time step
     real       :: dt, ot     ! modeling grid spacing and origin

  end type 

!----------------------------------------------------
! ashot      [0] - 1= assymetric shooting
! wswitch    [0] - 1= weighting in model space
! ampba      [0] - 1= model space amplitude balancing
! lpfil      [0] - 1= laplacian filter in model space
! gauss      [0] - 1= gaussian filter in model space
! mute       [0] - 1= muting the up-going in data space

  ! define taper/padding type
  type bc_values
     logical        :: ashot, residout, wfldout, UDout, wfrout, wfmout
     logical        :: DW, ampba, lpfil, gauss, mute, VDer
     integer        :: Op, nop, bndz, bndx, bndy, shotdir, wdata     
     real           :: xtapco, ytapco, ztapco, bmaskX, emaskX, bmaskY, emaskY
     real           :: bmask, emask
  end type
     

end module
