module type_mod

public                      :: axis, dat_grid, mod_grid, velo, sou_grid, rec_grid, abc_values

!--------------------------------------------------
  !!.. define type for axes
  type axis 
    integer 					:: n		! total number
    real    					:: d		! spacing
    real    					:: o		! origin
    real, allocatable				:: all(:)  	! values
  end type

!---------------------------------------------------
  !!.. define data grid
  type dat_grid
    type(axis) :: w, h, xd
  end type
!---------------------------------------------------
  !!.. define model grid
  type mod_grid
    type(axis) :: z, sh, xm, ym, th
  end type

!----------------------------------------------------

  ! define vel
  type velo
    type(axis) :: z, x, y, h
    real       :: zw, zsb
    logical     :: smooth    
  end type

!----------------------------------------------------

  ! define reflectivity
  type refl_grid
    type(axis) :: z, x, y
  end type

!----------------------------------------------------

  ! define sou grid
  type sou_grid
     type(axis) :: z, x, y, t
     real      :: zs
  end type 

!----------------------------------------------------

  ! define rec grid
  type rec_grid
     type(axis) :: z, x, y, t
 !    real       :: zr1, zr2
  end type 

!----------------------------------------------------
! ashot      [0] - 1= assymetric shooting
! wswitch    [0] - 1= weighting in model space
! ampba      [0] - 1= model space amplitude balancing
! lpfil      [0] - 1= laplacian filter in model space
! gauss      [0] - 1= gaussian filter in model space
! mute       [0] - 1= muting the up-going in data space

  ! define taper/padding type
  type bc_values
     logical        :: ashot, residout, wfldout, UDout, wfrout, wfmout
     logical        :: DW, ampba, lpfil, gauss, mute, VDer
     integer        :: Op, nop, bndz, bndx, bndy, shotdir, wdata     
     real           :: xtapco, ztapco, bmask, emask
  end type
     

end module
